﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4.7
@EndOfDesignText@
'Main application
Sub Class_Globals
	' change to match you app
	Private InitialPage As String = "frmCarousel/frmCarousel.html"  '<-------- First page to load
	' other variables needed
	Private AppPage As ABMPage
	Private theme As ABMTheme
	Private ws As WebSocket 'ignore
	Private ABM As ABMaterial 'ignore
	Private Pages As List
	Private PageNeedsUpload As List
	Private ABMPageId As String = ""
End Sub
Public Sub Initialize()
	Pages.Initialize
	PageNeedsUpload.Initialize
	' add your icons
	ABM.AddAppleTouchIcon("152.png", "152x152")
	ABM.AddMSTileIcon("144.png", "144x144")
	ABM.AddFavorityIcon("32.png", "32x32")
	ABM.AppVersion = ABMShared.AppVersion
	ABM.AppPublishedStartURL = ABMShared.AppPublishedStartURL
	ABM.ThresholdPxConsiderdSmall = 600
	ABM.ThresholdPxConsiderdMedium = 1024
	ABM.ActivateObfuscateCreatedWith("")
	'The next lines are specific to the donator specific components,
	'ABM.EnablePassiveEventListeners = false
	'ABM.ActivateUseCDN("", "")
	Dim p As Period
	p.Initialize
	p.Months = 3
	ABM.SiteExpires = DateUtils.AddPeriod(DateTime.Now, p)
	#If RELEASE
		ABM.PreloadAllJavascriptAndCSSFiles=True	' NEW
		ABM.ActivateGZip("", 1000) ' NEW
		ABM.AppDefaultPageCSSInline=True ' NEW
		ABM.AppDefaultPageJSInline=True ' NEW
		Dim folders As List ' NEW
		folders.Initialize
		folders.Add(File.DirApp & "/www/" & ABMShared.AppName & "/images")
		ABM.ActivatePNGOptimize("", folders, False , 9, False, True )
	#End If
	BuildPage
End Sub
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("Connected")
	ws = WebSocket1
	ABMPageId = ABM.GetPageID(AppPage, ABMShared.AppName,ws)
	If AppPage.WebsocketReconnected Then
		ABMShared.NavigateToPage(ws, "", "./")
		Return
	End If
	Dim session As HttpSession = ABM.GetSession(ws, ABMShared.SessionMaxInactiveIntervalSeconds) 'ignore
	ABMShared.RemoteIP = ws.UpgradeRequest.RemoteAddress
	If session.IsNew Then
		session.Invalidate
		ABMShared.NavigateToPage(ws, "", "./")
		Return
	End If
	' Prepare the page IMPORTANT!
	AppPage.Prepare
	' Run ConnectPage here in ABMApplication
	ConnectPage
	' navigate to the first page
	If ABMShared.NeedsAuthorization Then
		If session.GetAttribute2("IsAuthorized", "") = "" Then
			AppPage.ShowModalSheet("login")
			Return
		End If
	End If
	ABMShared.NavigateToPage(ws, "","./" & InitialPage)
End Sub
Private Sub WebSocket_Disconnected()
	Log("Disconnected")
End Sub
Sub Page_ParseEvent(Params As Map)
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	If eventName = "beforeunload" Then
		Log("preparing for url refresh")
		ABM.RemoveMeFromCache(ABMShared.CachedPages, ABMPageId)
		Return
	End If
	Dim caller As Object = AppPage.GetEventHandler(Me, eventName)
	If caller = Me Then
		If SubExists(Me, eventName) Then
			Params.Remove("eventname")
			Params.Remove("eventparams")
			' BEGIN NEW DRAGDROP
			If eventName = "page_dropped" Then
				AppPage.ProcessDroppedEvent(Params)
			End If
			' END NEW DRAGDROP
			Select Case Params.Size
				Case 0
					CallSub(Me, eventName)
				Case 1
					CallSub2(Me, eventName, Params.Get(eventParams(0)))
				Case 2
					If Params.get(eventParams(0)) = "abmistable" Then
						Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
						CallSub2(Me, eventName, PassedTables)
					Else
						CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
					End If
				Case Else
					' cannot be called directly, to many param
					CallSub2(Me, eventName, Params)
			End Select
		End If
	Else
		CallSubDelayed2(caller, "ParseEvent", Params) 'ignore
	End If
End Sub
public Sub AddPage(page As ABMPage)
	Pages.Add(page.Name)
	PageNeedsUpload.Add(ABM.WritePageToDisk(page, File.DirApp & "/www/" & ABMShared.AppName & "/" & page.Name & "/", page.PageHTMLName, ABMShared.NeedsAuthorization))
End Sub
public Sub StartServer(srvr As Server, srvrName As String, srvrPort As Int)
	ABM.WriteAppLauchPageToDisk(AppPage, File.DirApp & "/www/" & ABMShared.AppName, "index.html", ABMShared.NeedsAuthorization)
	' start the server
	srvr.Initialize(srvrName)
	' uncomment this if you want to directly access the app in the url without having to add the app name
	' e.g. 192.168.1.105:51042 or 192.168.1.105 if you are using port 80
	srvr.AddFilter( "/", "ABMRootFilter", False )
	' NEW V3 Cache Control
	srvr.AddFilter("/*", "ABMCacheControl", False)
	' NEW 4.00 custom error pages (optional) Needs the ABMErrorHandler class
	srvr.SetCustomErrorPages(CreateMap("org.eclipse.jetty.server.error_page.global": "/" & ABMShared.AppName & "/error")) ' OPTIONAL
	srvr.AddHandler("/" & ABMShared.AppName & "/error", "ABMErrorHandler", False) ' OPTIONAL
	srvr.AddWebSocket("/ws/" & ABMShared.AppName, "ABMApplication")
	For i =0 To Pages.Size - 1
		srvr.AddWebSocket("/ws/" & ABMShared.AppName & "/" & Pages.Get(i) , Pages.Get(i))
		If PageNeedsUpload.Get(i) Then
			srvr.AddHandler("/" & ABMShared.AppName & "/" & Pages.Get(i) & "/abmuploadhandler", "ABMUploadHandler", False)
		End If
	Next
	srvr.AddBackgroundWorker("ABMCacheScavenger")
	srvr.Port = srvrPort
	#If RELEASE
		srvr.SetStaticFilesOptions(CreateMap("gzip":True,"dirAllowed":False))
	#Else
		srvr.SetStaticFilesOptions(CreateMap("gzip":False,"dirAllowed":False))
	#End If
	srvr.Start
	Dim joServer As JavaObject = srvr
	joServer.GetFieldJO("server").RunMethod("stop", Null)
	joServer.GetFieldJO("context").RunMethodJO("getSessionHandler", Null).RunMethodJO("getSessionCookieConfig", Null).RunMethod("setMaxAge", Array(31536000)) ' 1 year
	' NEW FEATURE! Each App has its own Session Cookie
	joServer.GetFieldJO("context").RunMethodJO("getSessionHandler", Null).RunMethodJO("getSessionCookieConfig", Null).RunMethod("setName", Array(ABMShared.AppName.ToUpperCase))
	joServer.GetFieldJO("server").RunMethod("start", Null)
	Dim secs As Long = ABMShared.CacheScavengePeriodSeconds ' must be defined as a long, else you get a 'java.lang.RuntimeException: Method: setIntervalSec not matched.' error
	joServer.GetFieldJO("context").RunMethodJO("getSessionHandler", Null).RunMethodJO("getSessionIdManager", Null).RunMethodJO("getSessionHouseKeeper", Null).RunMethod("setIntervalSec", Array As Object(secs))
	Dim jo As JavaObject = srvr
	Dim connectors() As Object = jo.GetFieldJO("server").RunMethod("getConnectors", Null)
	Dim timeout As Long = ABMShared.SessionMaxInactiveIntervalSeconds*1000
	For Each c As JavaObject In connectors
		c.RunMethod("setIdleTimeout", Array(timeout))
	Next
	ABMShared.CachedPages = srvr.CreateThreadSafeMap
End Sub
public Sub StartServerHTTP2(srvr As Server, srvrName As String, srvrPort As Int, SSLsvrPort As Int,  SSLKeyStoreFileName As String, SSLKeyStorePassword As String, SSLKeyManagerPassword As String)
	ABM.WriteAppLauchPageToDisk(AppPage, File.DirApp & "/www/" & ABMShared.AppName, "index.html", ABMShared.NeedsAuthorization)
	Dim ssl As SslConfiguration
	ssl.Initialize
	ssl.SetKeyStorePath(File.DirApp, SSLKeyStoreFileName) 'path to keystore file
	ssl.KeyStorePassword = SSLKeyStorePassword
	ssl.KeyManagerPassword = SSLKeyManagerPassword
	srvr.SetSslConfiguration(ssl, SSLsvrPort)
	' start the server
	srvr.Initialize(srvrName)
	' uncomment this if you want to directly access the app in the url without having to add the app name
	' e.g. 192.168.1.105:51042 or 192.168.1.105 if you are using port 80
	srvr.AddFilter( "/", "ABMRootFilter", False )
	' NEW V3 Cache Control
	srvr.AddFilter("/*", "ABMCacheControl", False)
	' NEW 4.00  custom error pages (optional) Needs the ABMErrorHandler class
	srvr.SetCustomErrorPages(CreateMap("org.eclipse.jetty.server.error_page.global": "/" & ABMShared.AppName & "/error")) ' OPTIONAL
	srvr.AddHandler("/" & ABMShared.AppName & "/error", "ABMErrorHandler", False) ' OPTIONAL
	srvr.AddWebSocket("/ws/" & ABMShared.AppName, "ABMApplication")
	For i =0 To Pages.Size - 1
		srvr.AddWebSocket("/ws/" & ABMShared.AppName & "/" & Pages.Get(i) , Pages.Get(i))
		If PageNeedsUpload.Get(i) Then
			srvr.AddHandler("/" & ABMShared.AppName & "/" & Pages.Get(i) & "/abmuploadhandler", "ABMUploadHandler", False)
		End If
	Next
	srvr.AddBackgroundWorker("ABMCacheScavenger")
	srvr.Port = srvrPort
	srvr.Http2Enabled = True
	#If RELEASE
		srvr.SetStaticFilesOptions(CreateMap("gzip":True,"dirAllowed":False))
	#Else
		srvr.SetStaticFilesOptions(CreateMap("gzip":False,"dirAllowed":False))
	#End If
	srvr.Start
	Dim joServer As JavaObject = srvr
	joServer.GetFieldJO("server").RunMethod("stop", Null)
	joServer.GetFieldJO("context").RunMethodJO("getSessionHandler", Null).RunMethodJO("getSessionCookieConfig", Null).RunMethod("setMaxAge", Array(31536000)) ' 1 year
	' NEW FEATURE! Each App has its own Session Cookie
	joServer.GetFieldJO("context").RunMethodJO("getSessionHandler", Null).RunMethodJO("getSessionCookieConfig", Null).RunMethod("setName", Array(ABMShared.AppName.ToUpperCase))
	joServer.GetFieldJO("server").RunMethod("start", Null)
	Dim secs As Long = ABMShared.CacheScavengePeriodSeconds ' must be defined as a long, else you get a 'java.lang.RuntimeException: Method: setIntervalSec not matched.' error
	joServer.GetFieldJO("context").RunMethodJO("getSessionHandler", Null).RunMethodJO("getSessionIdManager", Null).RunMethodJO("getSessionHouseKeeper", Null).RunMethod("setIntervalSec", Array As Object(secs))
	Dim jo As JavaObject = srvr
	Dim connectors() As Object = jo.GetFieldJO("server").RunMethod("getConnectors", Null)
	Dim timeout As Long = ABMShared.SessionMaxInactiveIntervalSeconds*1000
	For Each c As JavaObject In connectors
		c.RunMethod("setIdleTimeout", Array(timeout))
	Next
	ABMShared.CachedPages = srvr.CreateThreadSafeMap
End Sub
public Sub BuildTheme()
	theme.Initialize("nb")
	theme.AddABMTheme(ABMShared.MyTheme)
	' add additional themes specific for this page
End Sub
public Sub BuildPage()
	' initialize the theme
	BuildTheme
	' build the local structure IMPORTANT!
	' initialize this page using our theme
	AppPage.InitializeWithTheme(ABMShared.AppName, "/ws/" & ABMShared.AppName, False, ABMShared.SessionMaxInactiveIntervalSeconds, theme)
	AppPage.ShowLoader=True
	AppPage.ShowLoaderType=ABM.LOADER_TYPE_MANUAL ' NEW
	AppPage.PageTitle = "Ask TeenCoach"
	AppPage.PageDescription = ""
	AppPage.PageHTMLName = "index.html"
	AppPage.PageKeywords = ""
	AppPage.PageSiteMapPriority = "0.5"
	AppPage.PageSiteMapFrequency = ABM.SITEMAP_FREQ_MONTHLY
	AppPage.UseGoogleAnalytics(ABMShared.TrackingID, Null) ' IMPORTANT Change this to your own TrackingID !!!!!!!
	' adding a navigation bar
	' create the page grid
	AppPage.AddRows(1,True, "").AddCells12(1,"")
	AppPage.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
End Sub
Public Sub ConnectPage()
	'add components for the page
	AppPage.Refresh ' IMPORTANT
	' NEW, because we use ShowLoaderType=ABM.LOADER_TYPE_MANUAL
	AppPage.FinishedLoading 'IMPORTANT
	AppPage.RestoreNavigationBarPosition
End Sub
' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	AppPage.SaveNavigationBarPosition
End Sub
Sub Page_FileUploaded(FileName As String, success As Boolean)
End Sub
Sub Page_ToastClicked(ToastId As String, Action As String)
End Sub
Sub Page_ToastDismissed(ToastId As String)
End Sub
'Sub Page_Authenticated(Params As Map)
'	Log("Authenticated " & Params.Get("name"))
'
'	ws.Session.SetAttribute("authType", Params.Get("network"))
'	ws.Session.SetAttribute("authName", Params.Get("name"))
'	ws.Session.SetAttribute("IsAuthorized", "true")
'	ABMShared.NavigateToPage(ws, ABMPageId, "./" & InitialPage)
'End Sub
